fn main() {
    // 11.字符串
    // Rust 语言提供了两种字符串
    //
    // Rust 核心内置的数据类型&str，字符串字面量 。
    // Rust 标准库中的一个 公开 pub 结构体。字符串对象 String。
    // 字面量&str
    // 字符串字面量的核心代码可以在模块 std::str 中找到。Rust 中的字符串字面量被称之为 字符串切片。因为它的底层实现是 切片。
    let lesson="Go语言微服务架构核心22讲";

    // 字面量 &str 就是在 编译时 就知道其值的字符串类型，它也是字符的集合，被硬编码赋值给一个变量。
    //
    // 字符串字面量模式是 静态 的，所以，字符串字面量从创建时开始会一直保存到程序结束。
    //
    // 字符串对象
    // 字符串对象并不是 Rust 核心内置的数据类型，它只是标准库中的一个 公开 pub 的结构体。

    // pub struct String
    // 字符串对象是使用 UTF-8 作为底层数据编码格式,长度可变的集合。
    //
    // 字符串对象在 堆 heap 中分配，可以在运行时提供字符串值以及相应的操作方法。

    // 新建字符串对象
    // String::new() //创建一个新的空字符串,它是静态方法。
    // String::from() //从具体的字符串字面量创建字符串对象。
    // 例子

    let s1 = String::new();
    println!("s1:{},s1-len:{}",s1,s1.len());
    //输出 s1:,s1-len:0

    let s2 = String::from("面向加薪学习");
    println!("s2:{},s2-len:{}",s2,s2.len());
    //输出 s2:面向加薪学习,s2-len:18
}
